#!/usr/bin/perl

#-------------------------------------------------------------------------------------#
#  :   
#-------------------------------------------------------------------------------------#
#       $input_string  $ENV{'CONTENT_LENGTH'}
read (STDIN, $input_string, $ENV{'CONTENT_LENGTH'});
#      
@input_pairS = split "&", $input_string;
#       
foreach $input_pair (@input_pairS)
 {
  #   -  
  ($name, $value) = split "=", $input_pair;
  $FORM{$name} = $value;
  #   -  
  ($key, $content) = split "=", $input_pair, 2;
  #     
  $content =~ s/\+/ /g;
  #  
  $content =~ s/%([a-fA-F--0-9][a-fA-F--0-9])/pack "C", hex($1)/eg;
  #    
  $content =~ s/\r//g;
  $FORM{$key} = $content;
 }
#-------------------------------------------------------------------------------------#
#  :   
#-----------------------------------------------------------------------#
#  : 
#-----------------------------------------------------------------------#
#  
my $file_size;
#  
my $file_type;
#  
my $file_version;
#  
my $file_content;
#-----------------------------------------------------------------------#
#  : 
#-----------------------------------------------------------------------#
#  : 
#-----------------------------------------------------------------------#
sub get_WORD
 { return unpack "v", (substr $_[0],$_[1],4); }

sub get_DWORD
 { return unpack "V", (substr $_[0],$_[1],4); }

sub get_WORD_symbols
 { return pack "v", $_[0]; }

sub get_DWORD_symbols
 { return pack "V", $_[0]; }

sub read_block
 {
  if(!-r $FORM{'tlk_file_path'}){ $stat_info .= (":  ".$FORM{'tlk_file_path'}."       !<br>"); reset_document(); };
  open FILE,$FORM{'tlk_file_path'};
  $stat_info .= ($_[1]."    ".$_[0]."<br>");
  binmode FILE;
  seek FILE,$_[0],0; read FILE,$_[2],$_[1];
  close FILE;
 }

sub get_String_Content
 {
  if($tlk_file_version eq "V3.0")
   { #   
     my $tlk_current_offset = get_DWORD($tlk_strings_data_table,$tlk_string_data_length*$_[0]+28);
     #   
     my $tlk_current_length = get_DWORD($tlk_strings_data_table,$tlk_string_data_length*$_[0]+32);
     #   
     return (substr $tlk_strings_content,$tlk_current_offset,$tlk_current_length); }
  elsif($tlk_file_version eq "V1  ")
   { my $tlk_current_offset = get_DWORD($tlk_strings_data_table,$tlk_string_data_length*$_[0]+18);
     my $tlk_current_length = get_DWORD($tlk_strings_data_table,$tlk_string_data_length*$_[0]+22);
     return (substr $tlk_strings_content,$tlk_current_offset,$tlk_current_length); }
 }

sub reset_document
 {
  $stat_info =~ s/\x5c/\\x5c/g;
  my $full_stat_info = "<b><font color='green'>".get_time()."</font></b><blockquote style='border: solid 1px gray; margin: 2px 10px 2px 10px; padding: 2px 4px 2px 4px;'>".$stat_info."  :&nbsp;<span id='span_stat_info'></span>&nbsp;.</blockquote>";
  print <<HTML;
  <script type='text/javascript'><!--
  parent.opener.document.getElementById("stat_info").innerHTML = "$full_stat_info";
  parent.opener.document.open_file_form.reset();
  parent.opener.FLAG_no_action = 0;
  parent.opener.document.getElementById("span_stat_info").innerHTML = (Math.round((parent.opener.get_request_time() - parent.opener.request_start_time)*Math.pow(10,parent.opener.float_precision)))/Math.pow(10,parent.opener.float_precision);
  // --></script>
HTML

  exit;
 }

sub get_date
 {
  ($day, $mn, $yr) = (localtime)[3..5];
  if($day < 10){ $day = "0$day"; };
  $mn = ($mn < 10) ? "0($mn+1)" : ($mn+1);
  if($yr < 2000){ $yr += 1900; };
  return "$day$mn$yr";
 }

sub get_time
 {
  ($sec, $min, $hour) = (localtime)[0..2];
  if($sec < 10){ $sec = "0$sec"; };
  if($min < 10){ $min = "0$min"; };
  if($hour < 10){ $hour = "0$hour"; };
  return "$hour:$min:$sec";
 }
#-----------------------------------------------------------------------#
#  : 
#-----------------------------------------------------------------------#
print "content-type: text/html; charset=Windows-1251\n\n";
#print "  ", $ENV{'CONTENT_LENGTH'}, " <br>";
#print $input_string."<br>";

$stat_info .= " : ".$FORM{'itm_file_path'}."<br>";

if(!-r $FORM{'itm_file_path'}){ $stat_info .= (":  ".$FORM{'itm_file_path'}."       !<br>"); reset_document(); };
#  ,  
open FILE,$FORM{'itm_file_path'}; binmode FILE;
#     ( )
(undef, undef, undef, undef, undef, undef, undef, $file_size) = stat FILE;
#      
seek FILE,0,0; read FILE,$file_content,$file_size;
#     
seek FILE,0,0; read FILE,$file_type,4;
seek FILE,4,0; read FILE,$file_version,4;
#  
close FILE;

$stat_info .= "->  0x0000, 4 ,   ( ) ... ".$file_type."<br>->  0x0004, 4 ,   ( ) ... ".$file_version."<br>";;

#       
$file_type =~ s/ //g;
$file_version =~ s/ //g;

#  
my $strref_count = 0;

# 
my $errors_count = 0;

#   ()
$stat_info .= "->  0x0008, 4 , DWORD ( ) ... ";
my $Item_Name_Generic = get_DWORD(substr $file_content,8,4);
   if($Item_Name_Generic eq 9999999 ||$Item_Name_Generic eq 4294967295)
    { $stat_info .= ":  ".$Item_Name_Generic." !<br>";
      $Item_Name_Generic = "";
      $errors_count++; }
   else
    { $strref_count++;
      $stat_info .= $Item_Name_Generic."<br>"; };
my $Item_Name_Generic_Content = " ";

#   ()
$stat_info .= "->  0x000c, 4 , DWORD ( ) ... ";
my $Item_Name_Identified = get_DWORD(substr $file_content,12,4);
   if($Item_Name_Identified eq 9999999 || $Item_Name_Identified eq 4294967295)
    { $stat_info .= ":  ".$Item_Name_Identified." !<br>";
      $Item_Name_Identified = "";
      $errors_count++; }
   else
    { $strref_count++;
      $stat_info .= $Item_Name_Identified."<br>"; };
my $Item_Name_Identified_Content = " ";

#  
$stat_info .= "->  0x0010, 8 ,    ( ) ... ";
my $Used_Up_Item = (substr $file_content,16,8); $stat_info .= $Used_Up_Item."<br>";
   $Used_Up_Item =~ s/\W//g;

#  ( 32 )
$stat_info .= "->  0x0018, 4 ,  32  ( ) ... ";
my $Flags = unpack "b32", (substr $file_content,24,4); $stat_info .= $Flags."<br>";

#    
$stat_info .= "->  0x001c, 2 , WORD ( ) ... ";
my $Item_category_index = get_WORD(substr $file_content,28,2); $stat_info .= $Item_category_index."<br>";

#    ( 32 )
$stat_info .= "->  0x001e, 4 ,  32  ( ) ... ";
my $Item_usability = unpack "b32", (substr $file_content,30,4); $stat_info .= $Item_usability."<br>";

#   BAM-   
$stat_info .= "->  0x0022, 2 ,    ( BAM-  ) ... ";
my $Inventory_portrait_value = (substr $file_content,34,2); $stat_info .= $Inventory_portrait_value."<br>";
   if($Inventory_portrait_value eq "  "){ $Inventory_portrait_value = "2020"; };

#      40
# unpack "C" -   
# unpack "h" - 16-  (  )
$stat_info .= "->  0x0024, 1 ,  ( ) ... ";
my $Minimum_level = (unpack "C", (substr $file_content,36,1));
if((0 <= $Minimum_level) && ($Minimum_level <= 40)){ $stat_info .= $Minimum_level."<br>"; }
else{ $Minimum_level = 0; $errors_count++; $stat_info .= ":  ".$Minimum_level."   0-40!<br>"; }

# 
$stat_info .= "->  0x0025, 1 ,  () ... ";
my $offset_0x0025 = (unpack "C", (substr $file_content,37,1)); $stat_info .= $offset_0x0025."<br>";

#      25
$stat_info .= "->  0x0026, 1 ,  ( ) ... ";
my $Minimum_strength = (unpack "C", (substr $file_content,38,1));
if((0 <= $Minimum_strength) && ($Minimum_strength <= 25)){ $stat_info .= $Minimum_strength."<br>"; }
else{ $Minimum_strength = 0; $errors_count++; $stat_info .= ":  ".$Minimum_strength."   0-25!<br>"; }

# 
$stat_info .= "->  0x0027, 1 ,  () ... ";
my $offset_0x0027 = (unpack "C", (substr $file_content,39,1)); $stat_info .= $offset_0x0027."<br>";

#       99
$stat_info .= "->  0x0028, 1 ,  (  ) ... ";
my $Minimum_strength_bonus = (unpack "C", (substr $file_content,40,1));
if((0 <= $Minimum_strength_bonus) && ($Minimum_strength_bonus <= 99)){ $stat_info .= $Minimum_strength_bonus."<br>"; }
else{ $Minimum_strength_bonus = 0; $errors_count++; $stat_info .= ":  ".$Minimum_strength_bonus."   0-99!<br>"; }

#    1 ( 8 )
$stat_info .= "->  0x0029, 1 ,  8  (  1) ... ";
my $kit_unusability_1 = (unpack "b8", (substr $file_content,41,1)); $stat_info .= $kit_unusability_1."<br>";

#      25
$stat_info .= "->  0x002a, 1 ,  ( ) ... ";
my $Minimum_intelligence = (unpack "C", (substr $file_content,42,1));
if((0 <= $Minimum_intelligence) && ($Minimum_intelligence <= 25)){ $stat_info .= $Minimum_intelligence."<br>"; }
else{ $Minimum_intelligence = 0; $errors_count++; $stat_info .= ":  ".$Minimum_intelligence."   0-25!<br>"; }

#    2 ( 8 )
$stat_info .= "->  0x002b, 1 ,  8  (  2) ... ";
my $kit_unusability_2 = (unpack "b8", (substr $file_content,43,1)); $stat_info .= $kit_unusability_2."<br>";

#      25
$stat_info .= "->  0x002c, 1 ,  ( ) ... ";
my $Minimum_dexterity = (unpack "C", (substr $file_content,44,1));
if((0 <= $Minimum_dexterity) && ($Minimum_dexterity <= 25)){ $stat_info .= $Minimum_dexterity."<br>"; }
else{ $Minimum_dexterity = 0; $errors_count++; $stat_info .= ":  ".$Minimum_dexterity."   0-25!<br>"; }

#    3 ( 8 )
$stat_info .= "->  0x002d, 1 ,  8  (  3) ... ";
my $kit_unusability_3 = (unpack "b8", (substr $file_content,45,1)); $stat_info .= $kit_unusability_3."<br>";

#      25
$stat_info .= "->  0x002e, 1 ,  ( ) ... ";
my $Minimum_wisdom = (unpack "C", (substr $file_content,46,1));
if((0 <= $Minimum_wisdom) && ($Minimum_wisdom <= 25)){ $stat_info .= $Minimum_wisdom."<br>"; }
else{ $Minimum_wisdom = 0; $errors_count++; $stat_info .= ":  ".$Minimum_wisdom."   0-25!<br>"; }

#    4 ( 8 )
$stat_info .= "->  0x002f, 1 ,  8  (  4) ... ";
my $kit_unusability_4 = unpack "b8", (substr $file_content,47,1); $stat_info .= $kit_unusability_4."<br>";

#      25
$stat_info .= "->  0x0030, 1 ,  ( ) ... ";
my $Minimum_constitution = (unpack "C", (substr $file_content,48,1));
if((0 <= $Minimum_constitution) && ($Minimum_constitution <= 25)){ $stat_info .= $Minimum_constitution."<br>"; }
else{ $Minimum_constitution = 0; $errors_count++; $stat_info .= ":  ".$Minimum_constitution."   0-25!<br>"; }

#  
$stat_info .= "->  0x0031, 1 , HEX ( ) ... ";
my $Weapon_Proficiency_code = (unpack "H", (substr $file_content,49,1)).(unpack "h", (substr $file_content,49,1)); $stat_info .= $Weapon_Proficiency_code."<br>";

#      25
$stat_info .= "->  0x0032, 1 ,  ( ) ... ";
my $Minimum_charisma = (unpack "C", (substr $file_content,50,1));
if((0 <= $Minimum_charisma) && ($Minimum_charisma <= 25)){ $stat_info .= $Minimum_charisma."<br>"; }
else{ $Minimum_charisma = 0; $errors_count++; $stat_info .= ":  ".$Minimum_charisma."   0-25!<br>"; }

#   
$stat_info .= "->  0x0034, 4 , DWORD ( ) ... ";
my $Base_value = get_DWORD(substr $file_content,52,4); $stat_info .= $Base_value."   ;-)<br>";

#   
$stat_info .= "->  0x0038, 2 , WORD ( ) ... ";
my $Max_stackable = get_WORD(substr $file_content,56,2); $stat_info .= $Max_stackable."<br>";

#  
$stat_info .= "->  0x003a, 8 ,    ( ) ... ";
my $Item_Icon = (substr $file_content,58,8); $stat_info .= $Item_Icon."<br>";
   $Item_Icon =~ s/\W//g;

#    
$stat_info .= "->  0x0042, 2 , WORD ( ) ... ";
my $Lore = get_WORD(substr $file_content,66,2); $stat_info .= $Lore."<br>";

#  ,   
$stat_info .= "->  0x0044, 8 ,    (  ) ... ";
my $Ground_Icon = (substr $file_content,68,8); $stat_info .= $Ground_Icon."<br>";
   $Ground_Icon =~ s/\W//g;

#  
$stat_info .= "->  0x004c, 4 , DWORD ( ) ... ";
my $Base_weight = get_DWORD(substr $file_content,76,4); $stat_info .= $Base_weight."<br>";

#   ()
$stat_info .= "->  0x0050, 4 , DWORD ( ) ... ";
my $Item_Description_Generic = get_DWORD(substr $file_content,80,4);
   if($Item_Description_Generic eq 9999999 || $Item_Description_Generic eq 4294967295)
    { $stat_info .= ":  ".$Item_Description_Generic." !<br>";
      $Item_Description_Generic = "";
      $errors_count++; }
   else
    { $stat_info .= $Item_Description_Generic."<br>";
      $strref_count++; };
my $Item_Description_Generic_Content = " ";

#   ()
$stat_info .= "->  0x0054, 4 , DWORD ( ) ... ";
my $Item_Description_Identified = get_DWORD(substr $file_content,84,4);
   if($Item_Description_Identified eq 9999999 || $Item_Description_Identified eq 4294967295)
    { $stat_info .= ":  ".$Item_Description_Identified." !<br>";
      $Item_Description_Identified = "";
      $errors_count++; }
   else
    { $stat_info .= $Item_Description_Identified."<br>";
      $strref_count++; };
my $Item_Description_Identified_Content = " ";

#   
$stat_info .= "->  0x0058, 8 ,    (  ) ... ";
my $Carried_Icon = (substr $file_content,88,8); $stat_info .= $Carried_Icon."<br>";
   $Carried_Icon =~ s/\W//g;

# ""
$stat_info .= "->  0x0060, 4 , DWORD () ... ";
my $Enchantment = get_DWORD(substr $file_content,96,4); $stat_info .= $Enchantment."<br>";
if($Enchantment == 0){ $Enchantment = ""; }else{ $Enchantment = "+".$Enchantment; }

#   
$stat_info .= "->  0x0064, 4 , DWORD (  ) ... ";
my $Ability_structs_offset =  get_DWORD(substr $file_content,100,4); $stat_info .= $Ability_structs_offset."<br>";

#   
$stat_info .= "->  0x0068, 2 , WORD (  ) ... ";
my $Ability_structs_count = get_WORD(substr $file_content,104,2); $stat_info .= $Ability_structs_count."<br>";

#   
$stat_info .= "->  0x006a, 4 , DWORD (  ) ... ";
my $Effects_structs_offset = get_DWORD(substr $file_content,106,4); $stat_info .= $Effects_structs_offset."<br>";

#    
$stat_info .= "->  0x006e, 2 , WORD (   ) ... ";
my $Effects_structs_count = get_WORD(substr $file_content,110,2); $stat_info .= $Effects_structs_count."<br>";

#    
$stat_info .= "->  0x0070, 2 , WORD (   ) ... ";
my $Global_effect_structs_count = get_WORD(substr $file_content,112,2); $stat_info .= $Global_effect_structs_count."<br>";

#  tlk-
if($FORM{'tlk_file_path'} ne "")
 {
  $stat_info .= "  : ".$FORM{'tlk_file_path'}."<br>->     ... ";
  if(!-r $FORM{'tlk_file_path'}){ $stat_info .= (":  ".$FORM{'tlk_file_path'}."       !<br>"); reset_document(); }
  else
   { open FILE,$FORM{'tlk_file_path'};
     #     ( )
     (undef, undef, undef, undef, undef, undef, undef, $tlk_file_size) = stat FILE;
     #  
     close FILE; }

  read_block(0,20,$tlk_header);
  #   
  $tlk_file_type = substr $tlk_header,0,4;
  if($tlk_file_type ne "TLK "){ $stat_info .= (":   ".$FORM{'tlk_file_path'}."  !<br>"); reset_document; };
  #  
  $tlk_file_version = substr $tlk_header,4,4;
  if($tlk_file_version eq "V3.0")
   { #     
     $tlk_file_strings = (get_DWORD($tlk_header,12) - 1);
     #        
     $tlk_strings_offset = get_DWORD($tlk_header,16); }
  elsif($tlk_file_version eq "V1  ")
   { $tlk_file_strings = (get_DWORD($tlk_header,10) - 1);
     $tlk_strings_offset = get_DWORD($tlk_header,14); }

  if($tlk_file_version eq "V3.0")
   { $tlk_header_length = 20; $tlk_string_data_length = 40; }
  elsif($tlk_file_version eq "V1  ")
   { $tlk_header_length = 18; $tlk_string_data_length = 26; }

  $stat_info .= "->       ... ";
  read_block($tlk_header_length,$tlk_strings_offset-$tlk_header_length,$tlk_strings_data_table);
  $stat_info .= "->     ... ";
  read_block($tlk_strings_offset,$tlk_file_size-$tlk_strings_offset,$tlk_strings_content);

  if($Item_Name_Generic ne "")
   { $Item_Name_Generic_Content = get_String_Content($Item_Name_Generic);
     #   (5c),   (0a  0d)   (22)  
     $Item_Name_Generic_Content =~ s/\x5c/\\x5c/g;
     $Item_Name_Generic_Content =~ s/\x0a/\\x0a/g;
     $Item_Name_Generic_Content =~ s/\x0d/\\x0d/g;
     $Item_Name_Generic_Content =~ s/\x22/\\x22/g;
     $stat_info .= "->      ".$Item_Name_Generic."<br>"; };
  if($Item_Name_Identified ne "")
   { $Item_Name_Identified_Content = get_String_Content($Item_Name_Identified);
     #   (5c),   (0a  0d)   (22)  
     $Item_Name_Identified_Content =~ s/\x5c/\\x5c/g;
     $Item_Name_Identified_Content =~ s/\x0a/\\x0a/g;
     $Item_Name_Identified_Content =~ s/\x0d/\\x0d/g;
     $Item_Name_Identified_Content =~ s/\x22/\\x22/g;
     $stat_info .= "->      ".$Item_Name_Identified."<br>"; };
  if($Item_Description_Generic ne "")
   { $Item_Description_Generic_Content = get_String_Content($Item_Description_Generic);
     #   (5c),   (0a  0d)   (22)  
     $Item_Description_Generic_Content =~ s/\x5c/\\x5c/g;
     $Item_Description_Generic_Content =~ s/\x0a/\\x0a/g;
     $Item_Description_Generic_Content =~ s/\x0d/\\x0d/g;
     $Item_Description_Generic_Content =~ s/\x22/\\x22/g;
     $stat_info .= "->      ".$Item_Description_Generic."<br>"; };
  if($Item_Description_Identified ne "")
   { $Item_Description_Identified_Content = get_String_Content($Item_Description_Identified);
     #   (5c),   (0a  0d)   (22)  
     $Item_Description_Identified_Content =~ s/\x5c/\\x5c/g;
     $Item_Description_Identified_Content =~ s/\x0a/\\x0a/g;
     $Item_Description_Identified_Content =~ s/\x0d/\\x0d/g;
     $Item_Description_Identified_Content =~ s/\x22/\\x22/g;
     $stat_info .= "->      ".$Item_Description_Identified."<br>"; };

 };

$stat_info =~ s/\x5c/\\x5c/g;
my $full_stat_info = "<b><font color='green'>".get_time()."</font></b><blockquote style='border: solid 1px gray; margin: 2px 10px 2px 10px; padding: 2px 4px 2px 4px;'>".$stat_info."  :&nbsp;<span id='span_stat_info'></span>&nbsp;.</blockquote>";

#      
print <<HTML;
<script type='text/javascript'><!--
parent.document.getElementById("file_info").innerHTML = "<nobr>: $file_size , : $file_type, : $file_version,  : $strref_count, : $errors_count</nobr>";

parent.document.main_form.load_itm.title = parent.document.main_form.load_itm.value;

parent.document.main_form.Item_Name_Generic.value = "$Item_Name_Generic";
parent.document.main_form.Item_Name_Generic_Content.value = "$Item_Name_Generic_Content";

parent.document.main_form.Item_Name_Identified.value = "$Item_Name_Identified";
parent.document.main_form.Item_Name_Identified_Content.value = "$Item_Name_Identified_Content";

parent.document.main_form.Item_Description_Generic.value = "$Item_Description_Generic";
parent.document.main_form.Item_Description_Generic_Content.value = "$Item_Description_Generic_Content";

parent.document.main_form.Item_Description_Identified.value = "$Item_Description_Identified";
parent.document.main_form.Item_Description_Identified_Content.value = "$Item_Description_Identified_Content";

parent.document.main_form.Item_category["$Item_category_index"].selected = true;
parent.document.getElementById("Item_category_code").innerHTML = parent.document.main_form.Item_category["$Item_category_index"].value;

for(var item_number = 0; item_number <= 46; item_number++)
 { if(parent.document.main_form.Weapon_Proficiency[item_number].value == ("$Weapon_Proficiency_code"))
   { parent.document.main_form.Weapon_Proficiency[item_number].selected = true; }; }
parent.document.getElementById("Weapon_Proficiency_code").innerHTML = "$Weapon_Proficiency_code";

parent.document.main_form.Used_Up_Item.value = "$Used_Up_Item";

for(var item_number = 0; item_number <= 36; item_number++)
 { if(parent.document.main_form.Inventory_portrait[item_number].value == ("$Inventory_portrait_value"))
   { parent.document.main_form.Inventory_portrait[item_number].selected = true; }; }
parent.document.getElementById("Inventory_portrait_index").innerHTML = ("$Inventory_portrait_value" == "2020") ? "  " : "$Inventory_portrait_value";

parent.document.main_form.Item_Icon.value = "$Item_Icon";

parent.document.main_form.Ground_Icon.value = "$Ground_Icon";

parent.document.main_form.Carried_Icon.value = "$Carried_Icon";

function get_Bit(_string,_bit){ return _string.charAt(_bit); }
for(var bn = 0; bn <= 31; bn++)
 { if(get_Bit("$Flags",bn) == 0)
    { parent.document.main_form.eval("Flags_"+bn).checked = false; }
   else if(get_Bit("$Flags",bn) == 1)
    { parent.document.main_form.eval("Flags_"+bn).checked = true; }
 }

parent.document.main_form.Base_value.value = "$Base_value";

parent.document.main_form.Base_weight.value = "$Base_weight";

parent.document.main_form.Max_stackable.value = "$Max_stackable";

parent.document.main_form.Lore.value = "$Lore";

parent.document.main_form.Enchantment.value = "$Enchantment";

for(var bn = 0; bn <= 31; bn++)
 { if(get_Bit("$Item_usability",bn) == 0)
    { parent.document.main_form.eval("Item_usability_"+bn).checked = false; }
   else if(get_Bit("$Item_usability",bn) == 1)
    { parent.document.main_form.eval("Item_usability_"+bn).checked = true; }
 }

for(var bn = 0; bn <= 7; bn++)
 { if(get_Bit("$kit_unusability_1",bn) == 0)
    { parent.document.main_form.eval("kit_unusability_1_"+bn).checked = false; }
   else if(get_Bit("$kit_unusability_1",bn) == 1)
    { parent.document.main_form.eval("kit_unusability_1_"+bn).checked = true; }
 }

for(var bn = 0; bn <= 7; bn++)
 { if(get_Bit("$kit_unusability_2",bn) == 0)
    { parent.document.main_form.eval("kit_unusability_2_"+bn).checked = false; }
   else if(get_Bit("$kit_unusability_2",bn) == 1)
    { parent.document.main_form.eval("kit_unusability_2_"+bn).checked = true; }
 }

for(var bn = 0; bn <= 7; bn++)
 { if(get_Bit("$kit_unusability_3",bn) == 0)
    { parent.document.main_form.eval("kit_unusability_3_"+bn).checked = false; }
   else if(get_Bit("$kit_unusability_3",bn) == 1)
    { parent.document.main_form.eval("kit_unusability_3_"+bn).checked = true; }
 }

for(var bn = 0; bn <= 7; bn++)
 { if(get_Bit("$kit_unusability_4",bn) == 0)
    { parent.document.main_form.eval("kit_unusability_4_"+bn).checked = false; }
   else if(get_Bit("$kit_unusability_4",bn) == 1)
    { parent.document.main_form.eval("kit_unusability_4_"+bn).checked = true; }
 }

parent.document.main_form.Minimum_level.value = "$Minimum_level";
parent.document.main_form.Minimum_level.readonly = false;

parent.document.main_form.Minimum_strength.value = "$Minimum_strength";
parent.document.main_form.Minimum_strength.readonly = false;

parent.document.main_form.Minimum_strength_bonus.value = "$Minimum_strength_bonus";
parent.document.main_form.Minimum_strength_bonus.readonly = false;

parent.document.main_form.Minimum_intelligence.value = "$Minimum_intelligence";
parent.document.main_form.Minimum_intelligence.readonly = false;

parent.document.main_form.Minimum_dexterity.value = "$Minimum_dexterity";
parent.document.main_form.Minimum_dexterity.readonly = false;

parent.document.main_form.Minimum_wisdom.value = "$Minimum_wisdom";
parent.document.main_form.Minimum_wisdom.readonly = false;

parent.document.main_form.Minimum_constitution.value = "$Minimum_constitution";
parent.document.main_form.Minimum_constitution.readonly = false;

parent.document.main_form.Minimum_charisma.value = "$Minimum_charisma";
parent.document.main_form.Minimum_charisma.readonly = false;

parent.document.getElementById("Ability_structs_count").innerHTML = "$Ability_structs_count";
parent.document.getElementById("Global_effect_structs_count").innerHTML = "$Global_effect_structs_count";

parent.document.getElementById("stat_info").innerHTML = "$full_stat_info";
parent.FLAG_no_action = 0;
parent.document.open_file_form.reset();
parent.document.getElementById("span_stat_info").innerHTML = (Math.round((parent.get_request_time() - parent.request_start_time)*Math.pow(10,parent.float_precision)))/Math.pow(10,parent.float_precision);
// --></script>
HTML
